/*********************************************
Project :  Robot suiveur de ligne
Version :  1
Date    : 05/12/2006
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: Gnration des signaux PWM
Comportement du robot  diffrentes vitesses

Nom du programme: testPWM.c

Chip type           : ATtiny26
Clock frequency     : 8,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 32
*********************************************/

#include <tiny26.h>
#include <delay.h>

// Prototype des fonctions
void Arret_Moteurs();
void Active_Timer();

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTA=0b00111000;;
DDRA=0b00111000;

// Port B initialization
// Func0=In Func1=Out Func2=In Func3=Out Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=0 State2=T State3=0 State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0x0A;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 4000,000 kHz
// Mode: PWMA & B top=OCR1C
// OC1A output: Non-Inv., /OC1A connected
// OC1B output: Non-Inv., /OC1B connected
PLLCSR=0x00;
TCCR1A=0x53;
TCCR1B=0x02;
TCNT1=0x00;
OCR1A=0x00;
OCR1B=0x00;
OCR1C=0xff;    

while (1)
      {
      
      Arret_Moteurs();  	// OCR1A et OCR1B = rglage du rapport cyclique
      delay_ms(3000);           // OCR1C = rglage de la frquence 
      Active_Timer();
      
             
      OCR1A=?;               //tau = 20%
      OCR1B=?;
      PORTA = 0b00101000;      
      delay_ms(3000);
            
      OCR1A=?;		//tau = 30%
      OCR1B=?;
      PORTA = 0b00110000;
      delay_ms(3000);
                
      OCR1A=?;		//tau = 40%
      OCR1B=?;
      PORTA = 0b00100000;
      delay_ms(1000);
              
      OCR1A=?; 		//tau = 50%
      OCR1B=?;
      PORTA = 0b00011000;
      delay_ms(1000);
                    
      OCR1A=?;               //tau = 60%
      OCR1B=?;
      PORTA = 0b00001000;
      delay_ms(1000);
                          
      OCR1A=?;               //tau = 70%
      OCR1B=?;
      PORTA = 0b00010000;
      delay_ms(1000);
                               
      OCR1A=?;                //tau = 80%
      OCR1B=?;
      PORTA = 0b00000000;
      delay_ms(1000);
                       
      };
}

void Arret_Moteurs()
{
      TCCR1A = 0x00; // Arrt PWM 
      TCCR1B = 0x00; 
      PORTB=0x0A;     // Arrt Moteur 
} 

void Active_Timer()
{
      TCCR1A=0x53;
      TCCR1B = 0x02;
} 