/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : Robot suiveur de ligne Mr Line
Version : 1
Date    : 17/12/2006
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: Commande des Dels IR, rrecption et commande des
DELs correspondantes 

Fichier : Stay_On_Line.c
Chip type           : ATtiny26
Clock frequency     : 8,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 32
*********************************************/

#include <tiny26.h>
#include <delay.h>

#define ACO 	ACSR.5      // Sortie du comparateur analogique      

// Signaux de commande des moteurs
#define CDEMOTG	OCR1A        // Cde moteur Gauche
#define CDEMOTD	OCR1B	    // Cde moteur Droite

// Rapport cyclique du signal de commande des moteurs
#define _40PC    150		// 40%
#define _50PC    125             // 50%
#define _60PC    100             // 60%

// Prototype des fonctions
void Arret_Moteurs();
void Active_Timer();

// Declare your global variables here  
// type		nom		Commentaires
//--------------------------------------------------
// Diffrentes commandes des moteurs
enum Etat_Commande_Moteur {CDE_ARRET,CDE_CENTRE1, CDE_CENTRE2, CDE_CENTRE3, CDE_DROITE, CDE_DROITE_PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS} EtatCdeMot = CDE_ARRET;
// Diffrentes positions du robot par rapport  la ligne 
enum Etat_Position_Robot {HORS_LIGNE,DROITE_PLUS,CENTRE_2, DROITE, GAUCHE_PLUS,CENTRE_3, GAUCHE, CENTRE_1} Position_Robot = HORS_LIGNE; 

// dbut prog principal
//---------------------
void main(void)
{

// Declare your local variables here
// type		nom		Commentaires
//--------------------------------------------------
unsigned char i;                // compteur de boucle
//unsigned char Position_Robot;   
unsigned char Cde_Del_IR;	// permet de multiplexer la commande des dels

 
// Input/Output Ports initialization
// Port A initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=In Func7=In 
// State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=T State7=T 
PORTA=0x3F;
DDRA=0x3F;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 4000,000 kHz
// Mode: PWMA & B top=OCR1C
// OC1A output: Non-Inv., /OC1A connected
// OC1B output: Non-Inv., /OC1B connected
PLLCSR=0x00;
TCCR1A=0x53;
TCCR1B=0x02;
TCNT1=0x00;
OCR1A=0x00;
OCR1B=0x00;
OCR1C=0xff;    

// Analog Comparator initialization
// Analog Comparator: On
ACSR=0x00;

while (1)
    {// dbut while (1)
    
// Fonction acqurir
// ----------------------------------------------------------------------------------------     
      Position_Robot = HORS_LIGNE; 	
      Cde_Del_IR = 1; 
 
      for (i=0;i<3;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
       {
        PORTA = ~Cde_Del_IR;
      	delay_us(19);	//  ajuster 
        if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
        PORTA = 0x3F;
        Cde_Del_IR = Cde_Del_IR << 1 ;
        delay_us(540);	//  ajuster
       } 
       			// Fin Acquisition de la position du robot par rapport  la ligne
// ----------------------------------------------------------------------------------------
       
// Dbut Traiter
// ----------------------------------------------------------------------------------------
      switch (EtatCdeMot)              
       {                                   
        case CDE_ARRET: Arret_Moteurs(); 
        		if (Position_Robot == CENTRE_1)
        		    { 
        		      delay_ms(3000);
        		      Active_Timer();
        		      EtatCdeMot = CDE_CENTRE1;
        		    }
        		    else  EtatCdeMot = CDE_ARRET;
        break;    
        
        case CDE_CENTRE1: CDEMOTG = _50PC; CDEMOTD = _50PC;
                          if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
                          	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
                          		else EtatCdeMot = CDE_CENTRE1;
        break;  
        
        case CDE_CENTRE2: EtatCdeMot = CDE_CENTRE1;   
        
        break;   
        
        case CDE_CENTRE3: EtatCdeMot = CDE_CENTRE1;
        break; 
        
        case CDE_DROITE:CDEMOTG = _40PC; CDEMOTD = _50PC; 
                         if (Position_Robot == CENTRE_1) EtatCdeMot = CDE_CENTRE1;
                          	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
                          		else EtatCdeMot = CDE_DROITE;
        break;   
        
        case CDE_DROITE_PLUS:CDEMOTG = _40PC; CDEMOTD = _60PC;
                             if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
                          	else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_ARRET;
                          		else EtatCdeMot = CDE_DROITE_PLUS;
        break;  
        
        case CDE_GAUCHE: CDEMOTG = _50PC; CDEMOTD = _40PC;
                         if (Position_Robot == CENTRE_1) EtatCdeMot = CDE_CENTRE1;
                          	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
                          		else EtatCdeMot = CDE_GAUCHE;
        break;  
        
        case CDE_GAUCHE_PLUS: CDEMOTG = _60PC; CDEMOTD = _40PC;
        	              if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
                          	else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_ARRET;
                          		else EtatCdeMot = CDE_GAUCHE_PLUS;
        break;  
       }             	// Fin Traiter
// ----------------------------------------------------------------------------------------  
      delay_us(704); //  ajuster    
      		
    }// fin while(1);
} // fin prog princ   

// Sous-programmes
// ---------------------------------
void Arret_Moteurs()
{
      TCCR1A = 0x00; // Arrt PWM 
      TCCR1B = 0x00; 
      PORTB=0x0A;     // Arrt Moteur 
} 

void Active_Timer()
{
      TCCR1A=0x53;
      TCCR1B = 0x02;
} 
